#include "preserves.hpp"
#include "googletest/gtest/gtest.h"

using namespace std;
using namespace Preserves;

TEST(Value, Basics) {
    auto vs = Value<>::from(vector<Value<>>{
        Value<>::from(1),
        Value<>::from(2U),
        Value<>::from(3),
    });
    ASSERT_EQ(3U, vs.size());
    ASSERT_EQ(1U, vs[0].to_unsigned());
    ASSERT_EQ(2U, vs[1].to_unsigned());
    ASSERT_EQ(3U, vs[2].to_unsigned());
}
